package com.caimei365.wechat.controller;


import com.caimei365.wechat.entity.WXBizJsonMsgCrypt;
import com.caimei365.wechat.exception.AesException;
import com.caimei365.wechat.utils.MessageUtil;
import com.google.gson.Gson;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;


@Slf4j
@RestController
@RequestMapping("wechat")
public class WechatCallbackApi {

    /**
     * 代开发模板的回调接口
     * @param request
     * @return
     * @throws AesException
     */
    @GetMapping("/callback")
    public String getCall(HttpServletRequest request) throws AesException {
        log.info("get--------------------------------->");
        //String msg_signature, String timestamp, String nonce, String echostr
        String sToken = "QDG6eK";
        String sCorpID = "wwa9819ec0b7c5fea4";
        String sEncodingAESKey = "jWmYm7qr5nMoAUwZRjGtBxmz3KA1tkAj3ykkR6q2B2C";
        String msg_signature = request.getParameter("msg_signature");
        String timestamp = request.getParameter("timestamp");
        String nonce = request.getParameter("nonce");
        String echostr = request.getParameter("echostr");


        WXBizJsonMsgCrypt wxcpt = new WXBizJsonMsgCrypt(sToken, sEncodingAESKey, sCorpID);
        log.info("msg_signature----------------------------->" + msg_signature);
        log.info("timestamp----------------------------->" + timestamp);
        log.info("nonce----------------------------->" + nonce);
        log.info("echostr----------------------------->" + echostr);
        // 需要返回的明文
        String sEchoStr = "";
        try {
            sEchoStr = wxcpt.VerifyURL(msg_signature, timestamp, nonce, echostr);
            log.info("verifyurl echostr: " + sEchoStr);
            // 验证URL成功，将sEchoStr返回
            // HttpUtils.SetResponse(sEchoStr);
        } catch (Exception e) {
            // 验证URL失败，错误原因请查看异常
            e.printStackTrace();
        }
        return sEchoStr;
    }

    /**
     * 获取Authcode
     * @param request
     * @return
     * @throws AesException
     */
    @GetMapping("/dkf/callback")
    public String getCallForDkf(HttpServletRequest request) throws Exception {
        log.info("代开发模板get回调--------------------------------->");
        String sToken = "QDG6eK";
        // SuiteId 模板id
        String sCorpID = "wpt0TTUAAAnD7mlTPUTd8bay_z10m5Rw";
        String sEncodingAESKey = "jWmYm7qr5nMoAUwZRjGtBxmz3KA1tkAj3ykkR6q2B2C";
        String msg_signature = request.getParameter("msg_signature");
        String timestamp = request.getParameter("timestamp");
        String nonce = request.getParameter("nonce");
        String echostr = request.getParameter("echostr");


        WXBizJsonMsgCrypt wxcpt = new WXBizJsonMsgCrypt(sToken, sEncodingAESKey, sCorpID);
        log.info("msg_signature----------------------------->" + msg_signature);
        log.info("timestamp----------------------------->" + timestamp);
        log.info("nonce----------------------------->" + nonce);
        log.info("echostr----------------------------->" + echostr);
        String sEchoStr = "";
        try {
            sEchoStr = wxcpt.VerifyURL(msg_signature, timestamp, nonce, echostr);
            log.info("sMsg：" + sEchoStr);

        } catch (Exception e) {
            // 解密失败，失败原因请查看异常
            e.printStackTrace();
        }
        return sEchoStr;
    }
    /**
     * 代开发应用的回调祭口 获取SuiteTicket
     * 1.代开发模板中可设置代开发模板回调URl，此接口会接收tx官方定时刷新的suite_ticket
     * 2.获取suite_ticket后通过https://qyapi.weixin.qq.com/cgi-bin/service/get_suite_token获取suite_access_token
     * 注：在校验解密的过程中cropId 为代开发应用的cropId
     * 关于suite_ticket和suite_access_token参考https://developer.work.weixin.qq.com/document/path/90600#14939
     * @param request
     * @return
     * @throws Exception
     */
    @PostMapping("/callback")
    public String postCall(HttpServletRequest request) throws Exception {
        log.info("代开发模板post回调--------------------------------->");
        String sToken = "QDG6eK";
        // SuiteId 模板id
        String sCorpID = "dkf01ed803e47f9a48";
        String sEncodingAESKey = "jWmYm7qr5nMoAUwZRjGtBxmz3KA1tkAj3ykkR6q2B2C";
        WXBizJsonMsgCrypt wxcpt = new WXBizJsonMsgCrypt(sToken, sEncodingAESKey, sCorpID);

        Map<String, String> stringStringMap = MessageUtil.parseXml(request);
        Gson gson = new Gson();
        String jsonString = gson.toJson(stringStringMap);
        log.info("jsonString ------------------------->" + jsonString);
        String sReqMsgSig = request.getParameter("msg_signature");
        String sReqTimeStamp = request.getParameter("timestamp");
        String sReqNonce = request.getParameter("nonce");
        log.info("msg_signature----------------------------->" + sReqMsgSig);
        log.info("timestamp----------------------------->" + sReqTimeStamp);
        log.info("nonce----------------------------->" + sReqNonce);
        log.info("requestBody----------------------------->" + jsonString);
        try {
            String sMsg = wxcpt.DecryptMsg(sReqMsgSig, sReqTimeStamp, sReqNonce, jsonString);
            log.info("sMsg：" + sMsg);

        } catch (Exception e) {
            // 解密失败，失败原因请查看异常
            e.printStackTrace();
        }
        return "success";
    }

}
